unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, inifiles, XPMan, StdCtrls, Jpeg, ShellAPI;

type
  TForm1 = class(TForm)
    XPManifest1: TXPManifest;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    Button5: TButton;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

var MyIni:TIniFile;
    MyPath:String;
    MyList:TStringList;
    i,j,k,x,y:integer;
    batch: boolean;

{$R *.dfm}
//---------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin

  //Form1.BorderStyle:=bsNone; //bsNone , bsSizeable
  //Form1.FormStyle:=fsNormal; //fsNormal , fsStayOnTop
  //Form1.Position:=poScreenCenter;
  //Form1.WindowState:=wsMaximized; //wsMaximized , wsNormal , wsMinimized

  MyIni := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  MyPath := ExtractFilePath(Application.ExeName);

  MyList := TStringList.Create;
  MyList.Clear;

  //Form1.Tag:=MyIni.ReadInteger('Parameter', 'Tag', Form1.Tag);

  batch:=false; //妸

end;
//---------------------------------------------------------------------------
procedure TForm1.FormActivate(Sender: TObject);
begin
//
end;
//---------------------------------------------------------------------------
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
//
end;
//---------------------------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

  //MyIni.WriteInteger('Parameter', 'Tag', Form1.Tag);

  MyList.Free;
  MyIni.Free;
end;
//---------------------------------------------------------------------------
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//
end;
//---------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
var jpg: TJPEGImage;
    bmp1,bmp2: TBitmap;
    x1,y1,x2,y2,x0,y0,dx,dy,x,y:integer;
begin

  if (not OpenDialog1.Execute) then
      begin
        batch:=false;
        exit;
      end;


  jpg :=TJPEGImage.Create;
  bmp1:=TBitmap.Create;
  bmp2:=TBitmap.Create;

  //Nഫe jpg  Assign  bmp1 
  jpg.LoadFromFile(OpenDialog1.FileName);
  bmp1.Assign(jpg);

  //ܪ Size
  bmp2.Width:=640;
  bmp2.Height:=480;


  //zL KTop kഫ Size (bmp1 -> bmp2)==========
  //HoO,iO nearest neighborhood ...
   x1:=bmp1.width;
   y1:=bmp1.height;
   x2:=bmp2.width;
   y2:=bmp2.height;
   dx:=0;
   x0:=0;
   for x:=0 to bmp2.width-1 do
   begin
     dy:=0;
     y0:=0;
     dx:=dx+x1;
     while dx>=x2 do
     begin
        inc(x0);
        dx:=dx-x2;
     end;
     for y:=0 to bmp2.height-1 do
     begin
        dy:=dy+y1;
        while dy>=y2 do
        begin
           inc(y0);
           dy:=dy-y2;
        end;
       bmp2.Canvas.Pixels[x,y]:=bmp1.Canvas.Pixels[x0,y0];
     end;
   end;
  //======================================================


  //Nഫ᪺ Size Assign  jpg 
  jpg.Assign(bmp2);

  jpg.SaveToFile('c:\1.jpg');
  if (not batch) then ShellExecute(0,nil,'c:\1.jpg',nil,nil,SW_SHOWMAXIMIZED);


  jpg.Free;
  bmp1.Free;
  bmp2.Free;
end;
//------------------------------------------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
var jpg: TJPEGImage;
    bmp1,bmp2: TBitmap;
    w,h,newW,newH: integer;
    dX,dY,x,y: double;
    i,j: integer;
    ix,iy: integer;                   // integer value of (x,y)
    fx,fy: double;                    // float value of (x,y)
    clr,
    clrR,clrG,clrB,
    nclr1,nclr2,nclr3,nclr4: Byte;   // color of neighbor 4 pixel
begin

  if (not batch) then
     begin
       if (not OpenDialog1.Execute) then
           begin
             exit;
           end;
     end;

  jpg :=TJPEGImage.Create;
  bmp1:=TBitmap.Create;
  bmp2:=TBitmap.Create;

  //Nഫe jpg  Assign  bmp1 
  jpg.LoadFromFile(OpenDialog1.FileName);
  bmp1.Assign(jpg);

  //ܪ Size
  bmp2.Width:=640;
  bmp2.Height:=480;

  //zL JerryKuo xkഫ Size (bmp1 -> bmp2)==========
  w := bmp1.Width;
  h := bmp1.Height;
  newW := 640;
  newH := 480;

  bmp2.Width  := newW;
  bmp2.Height := newH;

  (* Caculate the step size of movement *)
  dX := w/newW ; //bcb yk: (double)w/(double)newW;
  dY := h/newH ; //bcb yk: (double)h/(double)newH;

  for j := 0 to (newH - 1) do
     for i := 0 to (newW -1) do
     begin
       x := dX*i;
       y := dY*j;

       ix := Trunc(x);   iy := Trunc(y); //ix = (int)x;         iy = (int)y;
       fx := x - ix;     fy := y - iy;   //fx = x - (float)ix;  fy = y - (float)iy;

       nclr1 := GetRValue(bmp1.Canvas.Pixels[ix,iy]);
       nclr2 := GetRValue(bmp1.Canvas.Pixels[ix+1,iy]);
       nclr3 := GetRValue(bmp1.Canvas.Pixels[ix,iy+1]);
       nclr4 := GetRValue(bmp1.Canvas.Pixels[ix+1,iy+1]);
       // Bilinear
       clrR:=byte(Trunc( ((1.0-fx)*(1.0-fy)*nclr1+(fx)*(1.0-fy)*nclr2 +
                          (1.0-fx)*    (fy)*nclr3+(fx)*    (fy)*nclr4)
                 )     );

       nclr1 := GetGValue(bmp1.Canvas.Pixels[ix,iy]);
       nclr2 := GetGValue(bmp1.Canvas.Pixels[ix+1,iy]);
       nclr3 := GetGValue(bmp1.Canvas.Pixels[ix,iy+1]);
       nclr4 := GetGValue(bmp1.Canvas.Pixels[ix+1,iy+1]);
       // Bilinear
       clrG:=byte(Trunc( ((1.0-fx)*(1.0-fy)*nclr1+(fx)*(1.0-fy)*nclr2 +
                          (1.0-fx)*    (fy)*nclr3+(fx)*    (fy)*nclr4)
                 )     );

       nclr1 := GetBValue(bmp1.Canvas.Pixels[ix,iy]);
       nclr2 := GetBValue(bmp1.Canvas.Pixels[ix+1,iy]);
       nclr3 := GetBValue(bmp1.Canvas.Pixels[ix,iy+1]);
       nclr4 := GetBValue(bmp1.Canvas.Pixels[ix+1,iy+1]);
       // Bilinear
       clrB:=byte(Trunc( ((1.0-fx)*(1.0-fy)*nclr1+(fx)*(1.0-fy)*nclr2 +
                          (1.0-fx)*    (fy)*nclr3+(fx)*    (fy)*nclr4)
                 )     );

       bmp2.Canvas.Pixels[i,j] := TColor(RGB(clrR,clrG,clrB));
     end;  
  //==========================================================


  //Nഫ᪺ Size Assign  jpg 
  jpg.Assign(bmp2);

  jpg.SaveToFile('c:\2.jpg');
  if (not batch) then ShellExecute(0,nil,'c:\2.jpg',nil,nil,SW_SHOWMAXIMIZED);


  jpg.Free;
  bmp1.Free;
  bmp2.Free;
end;

//------------------------------------------------------------------------------
procedure TForm1.Button3Click(Sender: TObject);
var jpg: TJPEGImage;
    bmp1,bmp2: TBitmap;
    x1,y1,x2,y2,x0,y0:integer;
    x,y,dx,dy,nx,ny,i,j:integer;
    r,g,b,tot,c:integer;
begin

  if (not batch) then
     begin
       if (not OpenDialog1.Execute) then
           begin
             exit;
           end;
     end;

  jpg :=TJPEGImage.Create;
  bmp1:=TBitmap.Create;
  bmp2:=TBitmap.Create;

  //Nഫe jpg  Assign  bmp1 
  jpg.LoadFromFile(OpenDialog1.FileName);
  bmp1.Assign(jpg);

  //ܪ Size
  bmp2.Width:=640;
  bmp2.Height:=480;

  //zL KTop ƪkഫ Size (bmp1 -> bmp2) ==========
   x1:=bmp1.width;
   y1:=bmp1.height;
   x2:=bmp2.width;
   y2:=bmp2.height;
   dx:=0;
   x0:=0;
   for x:=0 to bmp2.width-1 do
   begin
     dy:=0;
     y0:=0;
     dx:=dx+x1;
     nx:=0;
     while dx>=x2 do
     begin
        inc(x0);
        inc(nx);
        dx:=dx-x2;
     end;
     for y:=0 to bmp2.height-1 do
     begin
        dy:=dy+y1;
        ny:=0;
        while dy>=y2 do
        begin
           inc(y0);
           inc(ny);
           dy:=dy-y2;
        end;
        r:=0; g:=0; b:=0;
        tot:=0;
        for i:=0 to nx do
        for j:=0 to ny do
        begin
           c:=bmp1.Canvas.Pixels[x0-i,y0-j];
           r:=r+(c shr 16);
           g:=g+((c shr 8) and 255);
           b:=b+(c and 255);
           inc(tot);
        end;

        r:=r div tot;
        g:=g div tot;
        b:=b div tot;
        c:=(r shl 16)+(g shl 8)+b;
       bmp2.Canvas.Pixels[x,y]:=c;
     end;
   end;
  //======================================================


  //Nഫ᪺ Size Assign  jpg 
  jpg.Assign(bmp2);

  jpg.SaveToFile('c:\3.jpg');
  if (not batch) then ShellExecute(0,nil,'c:\3.jpg',nil,nil,SW_SHOWMAXIMIZED);


  jpg.Free;
  bmp1.Free;
  bmp2.Free;
end;
//------------------------------------------------------------------------------
procedure TForm1.Button4Click(Sender: TObject);
var jpg: TJPEGImage;
    bmp1,bmp2: TBitmap;
begin

  if (not batch) then
     begin
       if (not OpenDialog1.Execute) then
           begin
             exit;
           end;
     end; 

  jpg :=TJPEGImage.Create;
  bmp1:=TBitmap.Create;
  bmp2:=TBitmap.Create;

  //Nഫe jpg  Assign  bmp1 
  jpg.LoadFromFile(OpenDialog1.FileName);
  bmp1.Assign(jpg);

  //ܪ Size
  bmp2.Width:=640;
  bmp2.Height:=480;

  //zL API ഫ Size (bmp1 -> bmp2) ==============================
  bmp2.PixelFormat := pfDevice; //pf32bit;
  SetStretchBltMode(bmp2.Canvas.Handle, COLORONCOLOR);
  StretchBlt(bmp2.Canvas.Handle,0,0,bmp2.Width,bmp2.Height,
             bmp1.Canvas.Handle,0,0,bmp1.Width,bmp1.Height,SRCCOPY);
  //================================================================


  //Nഫ᪺ Size Assign  jpg 
  jpg.Assign(bmp2);

  jpg.SaveToFile('c:\4.jpg');
  if (not batch) then ShellExecute(0,nil,'c:\4.jpg',nil,nil,SW_SHOWMAXIMIZED);


  jpg.Free;
  bmp1.Free;
  bmp2.Free;
end;
//------------------------------------------------------------------------------
procedure TForm1.Button5Click(Sender: TObject);
begin
  batch:=true;

  Button1Click(self);
  if (not batch) then exit;

  Button2Click(self);
  Button3Click(self);
  Button4Click(self);

  Memo1.Lines.SaveToFile('c:\test.htm');
  ShellExecute(0,nil,'c:\test.htm',nil,nil,SW_SHOWMAXIMIZED);

  batch:=false;
end;

end.
